## lua5.4 5.4.0

=== Makefile ===
# Makefile for installing Lua
# See doc/readme.html for installation and customization instructions.

# == CHANGE THE SETTINGS BELOW TO SUIT YOUR ENVIRONMENT =======================

# Your platform. See PLATS for possible values.
PLAT= guess

# Where to install. The installation starts in the src and doc directories,
# so take care if INSTALL_TOP is not an absolute path. See the local target.
# You may want to make INSTALL_LMOD and INSTALL_CMOD consistent with
# LUA_ROOT, LUA_LDIR, and LUA_CDIR in luaconf.h.
INSTALL_TOP= /usr/local
INSTALL_BIN= $(INSTALL_TOP)/bin
INSTALL_INC= $(INSTALL_TOP)/include
INSTALL_LIB= $(INSTALL_TOP)/lib
INSTALL_MAN= $(INSTALL_TOP)/man/man1
INSTALL_LMOD= $(INSTALL_TOP)/share/lua/$V
INSTALL_CMOD= $(INSTALL_TOP)/lib/lua/$V

# How to install. If your install program does not support "-p", then
# you may have to run ranlib on the installed liblua.a.
INSTALL= install -p
INSTALL_EXEC= $(INSTALL) -m 0755
INSTALL_DATA= $(INSTALL) -m 0644
#
# If you don't have "install" you can use "cp" instead.
# INSTALL= cp -p
# INSTALL_EXEC= $(INSTALL)
# INSTALL_DATA= $(INSTALL)

# Other utilities.
MKDIR= mkdir -p
RM= rm -f

# == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======

# Convenience platforms targets.
PLATS= guess aix bsd c89 freebsd generic linux linux-readline macosx mingw posix solaris

# What to install.
TO_BIN= lua luac
TO_INC= lua.h luaconf.h lualib.h lauxlib.h lua.hpp
TO_LIB= liblua.a
TO_MAN= lua.1 luac.1

# Lua version and release.
V= 5.4
R= $V.0

# Targets start here.
all:	$(PLAT)

$(PLATS) help test clean:
	@cd src && $(MAKE) $@

install: dummy
	cd src && $(MKDIR) $(INSTALL_BIN) $(INSTALL_INC) $(INSTALL_LIB) $(INSTALL_MAN) $(INSTALL_LMOD) $(INSTALL_CMOD)
	cd src && $(INSTALL_EXEC) $(TO_BIN) $(INSTALL_BIN)
	cd src && $(INSTALL_DATA) $(TO_INC) $(INSTALL_INC)
	cd src && $(INSTALL_DATA) $(TO_LIB) $(INSTALL_LIB)
	cd doc && $(INSTALL_DATA) $(TO_MAN) $(INSTALL_MAN)

uninstall:
	cd src && cd $(INSTALL_BIN) && $(RM) $(TO_BIN)
	cd src && cd $(INSTALL_INC) && $(RM) $(TO_INC)
	cd src && cd $(INSTALL_LIB) && $(RM) $(TO_LIB)
	cd doc && cd $(INSTALL_MAN) && $(RM) $(TO_MAN)

local:
	$(MAKE) install INSTALL_TOP=../install

# make may get confused with install/ if it does not support .PHONY.
dummy:

# Echo config parameters.
echo:
	@cd src && $(MAKE) -s echo
	@echo "PLAT= $(PLAT)"
	@echo "V= $V"
	@echo "R= $R"
	@echo "TO_BIN= $(TO_BIN)"
	@echo "TO_INC= $(TO_INC)"
	@echo "TO_LIB= $(TO_LIB)"
	@echo "TO_MAN= $(TO_MAN)"
	@echo "INSTALL_TOP= $(INSTALL_TOP)"
	@echo "INSTALL_BIN= $(INSTALL_BIN)"
	@echo "INSTALL_INC= $(INSTALL_INC)"
	@echo "INSTALL_LIB= $(INSTALL_LIB)"
	@echo "INSTALL_MAN= $(INSTALL_MAN)"
	@echo "INSTALL_LMOD= $(INSTALL_LMOD)"
	@echo "INSTALL_CMOD= $(INSTALL_CMOD)"
	@echo "INSTALL_EXEC= $(INSTALL_EXEC)"
	@echo "INSTALL_DATA= $(INSTALL_DATA)"

# Echo pkg-config data.
pc:
	@echo "version=$R"
	@echo "prefix=$(INSTALL_TOP)"
	@echo "libdir=$(INSTALL_LIB)"
	@echo "includedir=$(INSTALL_INC)"

# Targets that do not create files (not all makes understand .PHONY).
.PHONY: all $(PLATS) help test clean install uninstall local dummy echo pc

# (end of Makefile)

=== src/Makefile ===
# Makefile for building Lua
# See ../doc/readme.html for installation and customization instructions.

# == CHANGE THE SETTINGS BELOW TO SUIT YOUR ENVIRONMENT =======================

# Your platform. See PLATS for possible values.
PLAT= guess

CC= gcc -std=gnu99
CFLAGS= -O2 -Wall -Wextra -DLUA_COMPAT_5_3 $(SYSCFLAGS) $(MYCFLAGS)
LDFLAGS= $(SYSLDFLAGS) $(MYLDFLAGS)
LIBS= -lm $(SYSLIBS) $(MYLIBS)

AR= ar rcu
RANLIB= ranlib
RM= rm -f
UNAME= uname

SYSCFLAGS=
SYSLDFLAGS=
SYSLIBS=

MYCFLAGS=
MYLDFLAGS=
MYLIBS=
MYOBJS=

# Special flags for compiler modules; -Os reduces code size.
CMCFLAGS= -Os

# == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======

PLATS= guess aix bsd c89 freebsd generic linux linux-readline macosx mingw posix solaris

LUA_A=	liblua.a
CORE_O=	lapi.o lcode.o lctype.o ldebug.o ldo.o ldump.o lfunc.o lgc.o llex.o lmem.o lobject.o lopcodes.o lparser.o lstate.o lstring.o ltable.o ltm.o lundump.o lvm.o lzio.o
LIB_O=	lauxlib.o lbaselib.o lcorolib.o ldblib.o liolib.o lmathlib.o loadlib.o loslib.o lstrlib.o ltablib.o lutf8lib.o linit.o
BASE_O= $(CORE_O) $(LIB_O) $(MYOBJS)

LUA_T=	lua
LUA_O=	lua.o

LUAC_T=	luac
LUAC_O=	luac.o

ALL_O= $(BASE_O) $(LUA_O) $(LUAC_O)
ALL_T= $(LUA_A) $(LUA_T) $(LUAC_T)
ALL_A= $(LUA_A)

# Targets start here.
default: $(PLAT)

all:	$(ALL_T)

o:	$(ALL_O)

a:	$(ALL_A)

$(LUA_A): $(BASE_O)
	$(AR) $@ $(BASE_O)
	$(RANLIB) $@

$(LUA_T): $(LUA_O) $(LUA_A)
	$(CC) -o $@ $(LDFLAGS) $(LUA_O) $(LUA_A) $(LIBS)

$(LUAC_T): $(LUAC_O) $(LUA_A)
	$(CC) -o $@ $(LDFLAGS) $(LUAC_O) $(LUA_A) $(LIBS)

test:
	./lua -v

clean:
	$(RM) $(ALL_T) $(ALL_O)

depend:
	@$(CC) $(CFLAGS) -MM l*.c

echo:
	@echo "PLAT= $(PLAT)"
	@echo "CC= $(CC)"
	@echo "CFLAGS= $(CFLAGS)"
	@echo "LDFLAGS= $(SYSLDFLAGS)"
	@echo "LIBS= $(LIBS)"
	@echo "AR= $(AR)"
	@echo "RANLIB= $(RANLIB)"
	@echo "RM= $(RM)"
	@echo "UNAME= $(UNAME)"

# Convenience targets for popular platforms.
ALL= all

help:
	@echo "Do 'make PLATFORM' where PLATFORM is one of these:"
	@echo "   $(PLATS)"
	@echo "See doc/readme.html for complete instructions."

guess:
	@echo Guessing `$(UNAME)`
	@$(MAKE) `$(UNAME)`

AIX aix:
	$(MAKE) $(ALL) CC="xlc" CFLAGS="-O2 -DLUA_USE_POSIX -DLUA_USE_DLOPEN" SYSLIBS="-ldl" SYSLDFLAGS="-brtl -bexpall"

bsd:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_POSIX -DLUA_USE_DLOPEN" SYSLIBS="-Wl,-E"

c89:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_C89" CC="gcc -std=c89"
	@echo ''
	@echo '*** C89 does not guarantee 64-bit integers for Lua.'
	@echo ''

FreeBSD NetBSD OpenBSD freebsd:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_LINUX -DLUA_USE_READLINE -I/usr/include/edit" SYSLIBS="-Wl,-E -ledit" CC="cc"

generic: $(ALL)

Linux linux:	linux-noreadline

linux-noreadline:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_LINUX" SYSLIBS="-Wl,-E -ldl"

linux-readline:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_LINUX -DLUA_USE_READLINE" SYSLIBS="-Wl,-E -ldl -lreadline"

Darwin macos macosx:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_MACOSX -DLUA_USE_READLINE" SYSLIBS="-lreadline"

mingw:
	$(MAKE) "LUA_A=lua54.dll" "LUA_T=lua.exe" \
	"AR=$(CC) -shared -o" "RANLIB=strip --strip-unneeded" \
	"SYSCFLAGS=-DLUA_BUILD_AS_DLL" "SYSLIBS=" "SYSLDFLAGS=-s" lua.exe
	$(MAKE) "LUAC_T=luac.exe" luac.exe

posix:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_POSIX"

SunOS solaris:
	$(MAKE) $(ALL) SYSCFLAGS="-DLUA_USE_POSIX -DLUA_USE_DLOPEN -D_REENTRANT" SYSLIBS="-ldl"

# Targets that do not create files (not all makes understand .PHONY).
.PHONY: all $(PLATS) help test clean default o a depend echo

# Compiler modules may use special flags.
llex.o:
	$(CC) $(CFLAGS) $(CMCFLAGS) -c llex.c

lparser.o:
	$(CC) $(CFLAGS) $(CMCFLAGS) -c lparser.c

lcode.o:
	$(CC) $(CFLAGS) $(CMCFLAGS) -c lcode.c

# DO NOT DELETE

lapi.o: lapi.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lstring.h \
 ltable.h lundump.h lvm.h
lauxlib.o: lauxlib.c lprefix.h lua.h luaconf.h lauxlib.h
lbaselib.o: lbaselib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lcode.o: lcode.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lgc.h lstring.h ltable.h lvm.h
lcorolib.o: lcorolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lctype.o: lctype.c lprefix.h lctype.h lua.h luaconf.h llimits.h
ldblib.o: ldblib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ldebug.o: ldebug.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h lcode.h llex.h lopcodes.h lparser.h \
 ldebug.h ldo.h lfunc.h lstring.h lgc.h ltable.h lvm.h
ldo.o: ldo.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h lopcodes.h \
 lparser.h lstring.h ltable.h lundump.h lvm.h
ldump.o: ldump.c lprefix.h lua.h luaconf.h lobject.h llimits.h lstate.h \
 ltm.h lzio.h lmem.h lundump.h
lfunc.o: lfunc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h
lgc.o: lgc.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lstring.h ltable.h
linit.o: linit.c lprefix.h lua.h luaconf.h lualib.h lauxlib.h
liolib.o: liolib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
llex.o: llex.c lprefix.h lua.h luaconf.h lctype.h llimits.h ldebug.h \
 lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lgc.h llex.h lparser.h \
 lstring.h ltable.h
lmathlib.o: lmathlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lmem.o: lmem.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h
loadlib.o: loadlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lobject.o: lobject.c lprefix.h lua.h luaconf.h lctype.h llimits.h \
 ldebug.h lstate.h lobject.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h \
 lvm.h
lopcodes.o: lopcodes.c lprefix.h lopcodes.h llimits.h lua.h luaconf.h
loslib.o: loslib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lparser.o: lparser.c lprefix.h lua.h luaconf.h lcode.h llex.h lobject.h \
 llimits.h lzio.h lmem.h lopcodes.h lparser.h ldebug.h lstate.h ltm.h \
 ldo.h lfunc.h lstring.h lgc.h ltable.h
lstate.o: lstate.c lprefix.h lua.h luaconf.h lapi.h llimits.h lstate.h \
 lobject.h ltm.h lzio.h lmem.h ldebug.h ldo.h lfunc.h lgc.h llex.h \
 lstring.h ltable.h
lstring.o: lstring.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lstring.h lgc.h
lstrlib.o: lstrlib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltable.o: ltable.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
ltablib.o: ltablib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
ltm.o: ltm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lgc.h lstring.h ltable.h lvm.h
lua.o: lua.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
luac.o: luac.c lprefix.h lua.h luaconf.h lauxlib.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h lopcodes.h lopnames.h lundump.h
lundump.o: lundump.c lprefix.h lua.h luaconf.h ldebug.h lstate.h \
 lobject.h llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lstring.h lgc.h \
 lundump.h
lutf8lib.o: lutf8lib.c lprefix.h lua.h luaconf.h lauxlib.h lualib.h
lvm.o: lvm.c lprefix.h lua.h luaconf.h ldebug.h lstate.h lobject.h \
 llimits.h ltm.h lzio.h lmem.h ldo.h lfunc.h lgc.h lopcodes.h lstring.h \
 ltable.h lvm.h ljumptab.h
lzio.o: lzio.c lprefix.h lua.h luaconf.h llimits.h lmem.h lstate.h \
 lobject.h ltm.h lzio.h

# (end of Makefile)

=== debian/changelog ===
lua5.4 (5.4.0-2) unstable; urgency=medium

  * Add patches by upstream, which fix a few freshly introduced bugs.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 18 Jul 2020 18:10:14 +0300

lua5.4 (5.4.0-1) unstable; urgency=medium

  * The first upstream release.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 30 Jun 2020 16:51:40 +0300

lua5.4 (5.4.0~rc5-1) experimental; urgency=medium

  * New upstream release candidate.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 17 Jun 2020 12:49:10 +0300

lua5.4 (5.4.0~rc4-1) experimental; urgency=medium

  * New upstream release candidate.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 02 Jun 2020 23:46:53 +0300

lua5.4 (5.4.0~rc3-1) experimental; urgency=medium

  * New upstream release candidate.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 20 May 2020 10:12:52 +0300

lua5.4 (5.4.0~rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * Refresh patches.
  * Bump the standards version to 4.5.0.
  * Bump the debhelper compatibility level to 12.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 06 May 2020 10:33:50 +0300

lua5.4 (5.4.0~beta-1) experimental; urgency=medium

  * New upstream preliminary release.
  * Refresh patches.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 29 Oct 2019 10:23:48 +0300

lua5.4 (5.4.0~alpha-2) experimental; urgency=medium

  * Fix symbols in the linker version script.
  * Adapt a patch for lua5.3 by Helmut Grohne to fix FTCBFS. The patch
    libtoolizes during build to avoid a dependency on libtool-bin, and
    uses triplet-prefixed build tools (closes: #941649).
  * Fix the Lua version release number in pkgconfig scripts.
  * Add an alternatives for the lua.pc and lua-c++.pc pkgconfig scripts.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 13 Oct 2019 10:33:54 +0300

lua5.4 (5.4.0~alpha-1) experimental; urgency=medium

  * Initial release (closes: #932316).

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 17 Jul 2019 18:28:48 +0300

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment to use ccache
#export CCACHE=/usr/lib/ccache/

include /usr/share/dpkg/architecture.mk

ifeq ($(origin CC),default)
CC = $(CCACHE)$(DEB_HOST_GNU_TYPE)-gcc
endif

ifeq ($(origin CXX),default)
CXX = $(CCACHE)$(DEB_HOST_GNU_TYPE)-g++
endif

ifeq (hurd,$(DEB_HOST_ARCH_OS))
MYLIBS = -lpthread
endif

LUA_V = 5.4
LUA_FULL_V = 5.4.$(shell grep 'define LUA_VERSION_RELEASE\b' src/lua.h | cut -d '"' -f 2)
SONUM = 0
LUA = lua$(LUA_V)

DEB_DESTDIR := $(shell pwd)/debian/tmp/usr
LIB_PACKAGE_NAME = lib$(LUA)-$(SONUM)

PKG_DIR = $(DEB_DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
PKG_CONFIG_FILE = $(PKG_DIR)/$(LUA).pc
PKG_CONFIG_FILE_FBSD = $(PKG_DIR)/lua-5.4.pc
PKG_CONFIG_FILE_NODOT = $(PKG_DIR)/lua54.pc
PKGPP_CONFIG_FILE = $(PKG_DIR)/$(LUA)-c++.pc
PKGPP_CONFIG_FILE_FBSD = $(PKG_DIR)/lua-5.4-c++.pc
PKGPP_CONFIG_FILE_NODOT = $(PKG_DIR)/lua54-c++.pc

LUA_MULTIARCH_INCLUDE = $(DEB_DESTDIR)/include/$(DEB_HOST_MULTIARCH)/
LUA_MULTIARCH = lua5.4-deb-multiarch.h
%:
	dh $@

override_dh_auto_configure:
	mkdir debian/libtool
	cp debian/configure.ac debian/libtool/
	cd debian/libtool && LIBTOOLIZE='libtoolize -i' autoreconf -f -i
	dh_auto_configure --sourcedirectory=debian/libtool
	echo "#ifndef _LUA_DEB_MULTIARCH_" > src/$(LUA_MULTIARCH)
	echo "#define _LUA_DEB_MULTIARCH_" >> src/$(LUA_MULTIARCH)
	echo "#define DEB_HOST_MULTIARCH \"$(DEB_HOST_MULTIARCH)\"" >> \
		src/$(LUA_MULTIARCH)
	echo "#endif" >> src/$(LUA_MULTIARCH)

override_dh_auto_build:
	$(MAKE) linux MYLIBS=$(MYLIBS) LIBTOOL='$(CURDIR)/debian/libtool/libtool' CC='$(CC) -std=gnu99' CXX='$(CXX)'

override_dh_auto_install:
	# pkgconfig
	mkdir -p $(PKG_DIR)
	echo "prefix=/usr" > $(PKG_CONFIG_FILE)
	echo "major_version=$(LUA_V)" >> $(PKG_CONFIG_FILE)
	echo "version=$(LUA_FULL_V)" >> $(PKG_CONFIG_FILE)
	echo "lib_name_include=lua$(LUA_V)" >> $(PKG_CONFIG_FILE)
	echo "deb_host_multiarch=$(DEB_HOST_MULTIARCH)" >> $(PKG_CONFIG_FILE)
	cat debian/lua.pc.in >> $(PKG_CONFIG_FILE)
	ln -s $(shell basename $(PKG_CONFIG_FILE)) $(PKG_CONFIG_FILE_FBSD)
	ln -s $(shell basename $(PKG_CONFIG_FILE)) $(PKG_CONFIG_FILE_NODOT)
	echo "prefix=/usr" > $(PKGPP_CONFIG_FILE)
	echo "major_version=$(LUA_V)" >> $(PKGPP_CONFIG_FILE)
	echo "version=$(LUA_FULL_V)" >> $(PKGPP_CONFIG_FILE)
	echo "lib_name_include=lua$(LUA_V)" >> $(PKGPP_CONFIG_FILE)
	echo "deb_host_multiarch=$(DEB_HOST_MULTIARCH)" >> $(PKGPP_CONFIG_FILE)
	cat debian/lua-c++.pc.in >> $(PKGPP_CONFIG_FILE)
	ln -s $(shell basename $(PKGPP_CONFIG_FILE)) $(PKGPP_CONFIG_FILE_FBSD)
	ln -s $(shell basename $(PKGPP_CONFIG_FILE)) $(PKGPP_CONFIG_FILE_NODOT)
	# manpage
	cat doc/lua.1  | sed 's/TH LUA 1/TH LUA5.4 1/' > doc/lua5.4.1
	cat doc/luac.1 | sed 's/TH LUAC 1/TH LUAC5.4 1/' > doc/luac5.4.1
	# multiarch
	mkdir -p $(LUA_MULTIARCH_INCLUDE)
	cp src/$(LUA_MULTIARCH) $(LUA_MULTIARCH_INCLUDE)
	$(MAKE) install LIBTOOL=$(CURDIR)/debian/libtool/libtool
	mkdir -p $(DEB_DESTDIR)/share/lua$(LUA_V)/
	cp debian/version-script $(DEB_DESTDIR)/share/lua$(LUA_V)/
	sed -e's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' <debian/liblua5.4-dev.postinst.in >debian/liblua5.4-dev.postinst
	sed -e's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' <debian/liblua5.4-dev.prerm.in >debian/liblua5.4-dev.prerm

override_dh_auto_clean:
	dh_auto_clean
	rm -f doc/lua5.4.1 doc/luac5.4.1
	rm -f src/$(LUA_MULTIARCH)
	rm -f debian/liblua5.4-dev.postinst debian/liblua5.4-dev.prerm
	rm -Rf debian/libtool

override_dh_strip:
	dh_strip --dbg-package=$(LIB_PACKAGE_NAME)-dbg

=== debian/watch ===
# test with:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package lua5.3
version=3
https://www.lua.org/ftp/lua-(5\.4.*)\.tar\.gz

opts="dversionmangle=s/~~/-/g;s/~/-/g, \
      uversionmangle=s/-w/~~w/g;s/-/~/g" \
https://www.lua.org/work/lua-(5\.4.*[^s])\.tar\.gz

## lua5.4 5.4.1

=== debian/changelog ===
lua5.4 (5.4.1-1) unstable; urgency=medium

  * New upstream release. This release fixes the following security bugs:
    - CVE-2020-15888, mishandling the interaction between stack resizes
      and garbage collection (closes: #972101)
    - CVE-2020-24342 allowing a stack redzone cross (closes: #971012)
    - CVE-2020-24369 attempting to access debug information via the line
      hook of a stripped function (closes: #971013)
    - CVE-2020-24370 allowing a negation overflow and segmentation fault
      in getlocal and setlocal (closes: #971613)
    - CVE-2020-24371 active barriers during sweep phase (closes: #971010)
  * Remove no longer necessary patches.

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 21 Nov 2020 17:58:27 +0300

## lua5.4 5.4.2

=== src/Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 MYOBJS=
 
 # Special flags for compiler modules; -Os reduces code size.
-CMCFLAGS= -Os
+CMCFLAGS= 
 
 # == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======

=== debian/changelog ===
lua5.4 (5.4.2-2) unstable; urgency=medium

  * Enable readline support (thanks to Widianto Nur F).

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 12 Jan 2021 23:02:10 +0300

lua5.4 (5.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 06 Dec 2020 14:05:10 +0300

=== debian/control ===
Source: lua5.4
Section: interpreters
Priority: optional
Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
Uploaders: Sergei Golovan <sgolovan@debian.org>
Build-Depends: debhelper (>= 12), quilt (>= 0.40), libtool, libreadline-dev, autoconf
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/lua-team/lua5.4.git
Vcs-Browser: https://salsa.debian.org/lua-team/lua5.4
Homepage: http://www.lua.org

Package: lua5.4
Architecture: any
Multi-Arch: foreign
Provides: lua
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple, extensible, embeddable programming language
 Lua is a powerful, light-weight programming language designed for extending
 applications.  The language engine is accessible as a library, having a C
 API which allows the application to exchange data with Lua programs and also
 to extend Lua with C functions.  Lua is also used as a general-purpose,
 stand-alone language through the simple command line interpreter provided.
 .
 This package contains the Lua command line interpreter and bytecode compiler.
 Install it if you are developing or using Lua scripts.

Package: liblua5.4-dev
Architecture: any
Multi-Arch: same
Depends: liblua5.4-0 (= ${binary:Version}), libc6-dev|libc-dev, libreadline-dev, ${misc:Depends}
Recommends: pkg-config, libtool-bin
Section: libdevel
Description: Development files for the Lua language version 5.4
 Lua is a powerful, light-weight programming language designed for extending
 applications.  The language engine is accessible as a library, having a C
 API which allows the application to exchange data with Lua programs and also
 to extend Lua with C functions.  Lua is also used as a general-purpose,
 stand-alone language through the simple command line interpreter provided.
 .
 This package contains developer resources for using the Lua library.
 Install it if you are developing programs which use the Lua C API.
 .
 This package also contains the official manual covering the Lua language
 and C API.

Package: liblua5.4-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Shared library for the Lua interpreter version 5.4
 Lua is a powerful, light-weight programming language designed for extending
 applications.  The language engine is accessible as a library, having a C
 API which allows the application to exchange data with Lua programs and also
 to extend Lua with C functions.  Lua is also used as a general-purpose,
 stand-alone language through the simple command line interpreter provided.
 .
 This package contains runtime libraries.  You shouldn't need to install it
 explicitly.

Package: liblua5.4-0-dbg
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, liblua5.4-0 (= ${binary:Version}), ${misc:Depends}
Section: debug
Priority: optional
Description: Debug symbols for the Lua shared library interpreter
 This package contains the debugging symbols for liblua5.4 and lua5.4

=== debian/rules ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	echo "#endif" >> src/$(LUA_MULTIARCH)
 
 override_dh_auto_build:
-	$(MAKE) linux MYLIBS=$(MYLIBS) LIBTOOL='$(CURDIR)/debian/libtool/libtool' CC='$(CC) -std=gnu99' CXX='$(CXX)'
+	$(MAKE) linux-readline MYLIBS=$(MYLIBS) LIBTOOL='$(CURDIR)/debian/libtool/libtool' CC='$(CC) -std=gnu99' CXX='$(CXX)'
 
 override_dh_auto_install:
 	# pkgconfig

## lua5.4 5.4.3

=== debian/changelog ===
lua5.4 (5.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Sergei Golovan <sgolovan@debian.org>  Tue, 17 Aug 2021 10:50:26 +0300

## lua5.4 5.4.4

=== debian/changelog ===
lua5.4 (5.4.4-1) unstable; urgency=medium

  * New upstream release. This release fixes the following security bugs:
    - CVE-2021-43519, stack overflow in lua_resume of ldo.c in Lua
      Interpreter 5.1.0~5.4.4 allows attackers to perform a Denial of
      Service via a crafted script file (closes: #1000228).
    - CVE-2021-44647, Lua 5.4.4 and 5.4.2 are affected by SEGV by type
      confusion in funcnamefromcode function in ldebug.c which can cause
      a local denial of service (closes: #1004189).

 -- Sergei Golovan <sgolovan@debian.org>  Mon, 07 Feb 2022 10:34:34 +0300

=== debian/watch ===
# test with:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package lua5.3
version=3
https://www.lua.org/ftp/lua-(5\.4.*)\.tar\.gz

## lua5.4 5.4.6

=== debian/changelog ===
lua5.4 (5.4.6-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:03:50 +0000

lua5.4 (5.4.6-3build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Mar 2024 13:57:16 +0100

lua5.4 (5.4.6-3) unstable; urgency=high

  [ P. J. McDermott ]
  * Fix completely broken C++ library missing all "lua*" function symbols.
    0003-extern_C.patch was removed in 5.4.6-1 per request in #1032533,
    replacing all the C symbols with C++ mangled names, but the export map
    debian/version-script listed only C symbols. (closes: #1063707)
    - Extend DEP-8 test to check C++ library.
  * Update liblua5.4-dev Recommends from pkg-config to pkgconf.
    (Fixes lintian error tag depends-on-obsolete-package)
  * Add Rules-Requires-Root: no.
    (Fixes lintian pedantic tag silent-on-rules-requiring-root)
  * Move "-e" from "#!" line to "set" command in lua5.4 prerm script.
    (Fixes lintian pedantic tag maintainer-script-without-set-e)
  * Add debian/salsa-ci.yml.

 -- Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>  Sun, 11 Feb 2024 07:29:32 -0500

lua5.4 (5.4.6-2) unstable; urgency=medium

  * Team upload

  [ Lena Voytek ]
  * Make some packaging improvements (closes: #1056991)
    - Add DEP-8 tests for basic functionality
      + d/t/interpreter: Test lua interpreter
      + d/t/liblua: Test lua C api
    - d/p/0001-build-system.patch: Use default test environment:
      Instead of overriding testing with libtool which now fails with -dlopen
      argument, the original ./$(LUA_T) -v is used as it is works correctly
      with 5.4.6
    - d/configure.ac: Remove AC_PROG_LIBTOOL entry:
      AC_PROG_LIBTOOL is a deprecated macro for initializing libtool. LT_INIT
      already covers this functionality so no other action is required.
    - d/liblua5.4-0.symbols: Add symbols file for lua 5.4 libraries

  [ Gianfranco Costamagna ]
  * d/version-script: Export additional missing symbols (closes: #1034800)
  * Update watch file to version 4
  * Fix some copyright typos
  * Drop trailing spaces and newlines
  * Add R^3: no
  * Use https for copyright machine readable file
  * Explicit set -e on prerm and postinst files to please lintian
  * Drop priority field on dbg to please lintian
  * Drop unused patch to please lintian
  * Drop dbg package to please lintian (closes: #1050990)
  * Drop quilt and auto* dependencies, already satisfied by newer debhelper
    and compat level 13

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 27 Nov 2023 08:23:09 -0700

lua5.4 (5.4.6-1) unstable; urgency=medium

  * New upstream release (closes: #1041902).
  * Remove no longer necessary patches which fixed CVE-2022-28805 and
    CVE-2022-33099 in version 5.4.4.
  * Refresh patches.
  * Fix building the package twice (closes: #1046480).
  * Bump the debhelper compatibility level to 13.
  * Bump the standards version to 4.6.2.

 -- Sergei Golovan <sgolovan@debian.org>  Wed, 14 Jun 2023 15:52:06 +0300

lua5.4 (5.4.4-3) unstable; urgency=medium

  * Add a patch from upstream which fixes CVE-2022-33099, double free
    in a situation when error occurs while handling an error
    (closes: #1014935).

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 17 Jul 2022 14:56:01 +0300

lua5.4 (5.4.4-2) unstable; urgency=medium

  * Add a patch from upstream which fixes CVE-2022-28805, segmentation fault
    due to a heap overflow when parsing ENV with <const> (closes: #1010265).

 -- Sergei Golovan <sgolovan@debian.org>  Sat, 30 Apr 2022 07:38:29 +0300

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: lua5.4
 Section: interpreters
 Priority: optional
-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Sergei Golovan <sgolovan@debian.org>
-Build-Depends: debhelper (>= 12), quilt (>= 0.40), libtool, libreadline-dev, autoconf
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13), libreadline-dev
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/lua-team/lua5.4.git
 Vcs-Browser: https://salsa.debian.org/lua-team/lua5.4
 Homepage: http://www.lua.org
+Rules-Requires-Root: no
 
 Package: lua5.4
 Architecture: any
@@ -28,7 +30,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: liblua5.4-0 (= ${binary:Version}), libc6-dev|libc-dev, libreadline-dev, ${misc:Depends}
-Recommends: pkg-config, libtool-bin
+Recommends: pkgconf, libtool-bin
 Section: libdevel
 Description: Development files for the Lua language version 5.4
  Lua is a powerful, light-weight programming language designed for extending
@@ -58,13 +60,3 @@
  .
  This package contains runtime libraries.  You shouldn't need to install it
  explicitly.
-
-Package: liblua5.4-0-dbg
-Architecture: any
-Multi-Arch: same
-Depends: ${shlibs:Depends}, liblua5.4-0 (= ${binary:Version}), ${misc:Depends}
-Section: debug
-Priority: optional
-Description: Debug symbols for the Lua shared library interpreter
- This package contains the debugging symbols for liblua5.4 and lua5.4
-

=== debian/rules ===
--- 
+++ 
@@ -85,10 +85,13 @@
 
 override_dh_auto_clean:
 	dh_auto_clean
+	rm -rf src/.libs
+	rm -f src/*-c++.o
+	rm -f src/*.lo
 	rm -f doc/lua5.4.1 doc/luac5.4.1
 	rm -f src/$(LUA_MULTIARCH)
 	rm -f debian/liblua5.4-dev.postinst debian/liblua5.4-dev.prerm
 	rm -Rf debian/libtool
 
 override_dh_strip:
-	dh_strip --dbg-package=$(LIB_PACKAGE_NAME)-dbg
+	dh_strip --dbgsym-migration='liblua5.4-0-dbg (<< 5.4.6-2~)'

=== debian/tests/control ===
Tests: interpreter
Depends: lua5.4

Tests: liblua
Depends: liblua5.4-dev, gcc, g++

## lua5.4 5.4.7

=== debian/changelog ===
lua5.4 (5.4.7-1) unstable; urgency=medium

  * New upstream release.
  * Bump the standards version to 4.7.0.

 -- Sergei Golovan <sgolovan@debian.org>  Thu, 28 Nov 2024 12:14:18 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: lua5.4
 Section: interpreters
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
+Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Sergei Golovan <sgolovan@debian.org>
 Build-Depends: debhelper-compat (= 13), libreadline-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/lua-team/lua5.4.git
 Vcs-Browser: https://salsa.debian.org/lua-team/lua5.4
 Homepage: http://www.lua.org

=== debian/watch ===
# test with:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package lua5.3
version=4
https://www.lua.org/ftp/lua-(5\.4.*)\.tar\.gz

## lua5.4 5.4.8

=== Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 # == END OF USER SETTINGS -- NO NEED TO CHANGE ANYTHING BELOW THIS LINE =======
 
 # Convenience platforms targets.
-PLATS= guess aix bsd c89 freebsd generic linux linux-readline macosx mingw posix solaris
+PLATS= guess aix bsd c89 freebsd generic ios linux linux-readline macosx mingw posix solaris
 
 # What to install.
 TO_BIN= lua luac
@@ -46,7 +46,7 @@
 
 # Lua version and release.
 V= 5.4
-R= $V.0
+R= $V.8
 
 # Targets start here.
 all:	$(PLAT)

=== debian/changelog ===
lua5.4 (5.4.8-1) unstable; urgency=medium

  * New upstream release.
  * Update the liblua5.4-0 symbols list.
  * Bump the standards version to 4.7.2.

 -- Sergei Golovan <sgolovan@debian.org>  Sun, 10 Aug 2025 11:58:08 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Lua Team <pkg-lua-devel@lists.alioth.debian.org>
 Uploaders: Sergei Golovan <sgolovan@debian.org>
 Build-Depends: debhelper-compat (= 13), libreadline-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/lua-team/lua5.4.git
 Vcs-Browser: https://salsa.debian.org/lua-team/lua5.4
 Homepage: http://www.lua.org
